///File : MainPanel.hpp
//------------------------------------------------------------------------------
/*
    This file is part of LCDnurse.

    LCDnurse is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LCDnurse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LCDnurse.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/spinctrl.h>
#include <wx/event.h>
#include <wx/stdpaths.h>
#include <wx/statline.h>
#include <wx/listctrl.h>

#include <vector>
//------------------------------------------------------------------------------
#include "config.hpp"
#include "findFile.hpp"
#include "ControlDialog.hpp"
#include "DataManager.hpp"
//------------------------------------------------------------------------------

#if not defined MAIN_PANEL_HPP_LCD_NURSE
#define MAIN_PANEL_HPP_LCD_NURSE


class MainPanel : public wxPanel
{
public:
    MainPanel(wxWindow* parent, wxWindowID id, DataManager *Data, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTAB_TRAVERSAL | wxBORDER_SIMPLE );
    void OnPaint(wxPaintEvent& event);
    void SetBrush(const char &color, wxPaintDC &dc);
    void KeyDown(wxKeyEvent& event);
    void OnClick(wxMouseEvent &event);
    void OnMouseMove(wxMouseEvent &event);
    void OnMouseWheel(wxMouseEvent &event);
    void OnTimer(wxTimerEvent &event);

    void StartRepair();
    void StopRepair();

private:
    ControlDialog *m_ControlDialog;
    DataManager *m_Data;

    bool m_isDrawing;
    wxPoint m_beginPt;
    wxPoint m_currentPt;
    char m_currentRectColor;

    bool m_isRepairing;
    bool m_isBlack;

    wxTimer *m_timer;
};

#endif // MAIN_PANEL_HPP_LCD_NURSE
